import Popover from "@dft-vue-2-opentiny/vue-popover";
import Input from "@dft-vue-2-opentiny/vue-input";
import Currency from "@dft-vue-2-opentiny/vue-currency";
import Button from "@dft-vue-2-opentiny/vue-button";
import DatePicker from "@dft-vue-2-opentiny/vue-date-picker";
import { IconCoin } from "@dft-vue-2-opentiny/vue-icon";
import { defineComponent, $prefix, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/amount/vue";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dft-vue-2-opentiny/vue-theme/amount/index.css";
var __vue2_script = defineComponent({
  inheritAttrs: false,
  name: $prefix + "Amount",
  components: {
    TinyPopover: Popover,
    TinyInput: Input,
    TinyButton: Button,
    TinyCurrency: Currency,
    TinyDatePicker: DatePicker,
    IconCoin: IconCoin()
  },
  props: {
    modelValue: {
      type: [Number, String]
    },
    tabindex: {
      type: String,
      default: "1"
    },
    size: String,
    placeholder: {
      type: String,
      default: ""
    },
    currency: {
      type: String,
      default: "CNY"
    },
    date: [String, Date],
    dateAllowEmpty: {
      type: Boolean,
      default: false
    },
    digits: {
      type: Number,
      default: 2
    },
    rounding: {
      type: Boolean,
      default: true
    },
    maxLen: {
      type: Number,
      default: 15
    },
    negative: {
      type: Boolean,
      default: true
    },
    disabled: {
      type: Boolean,
      default: false
    },
    fetchCurrency: Function,
    fields: Object,
    popperClass: String,
    popperAppendToBody: {
      type: Boolean,
      default: true
    },
    format: Object,
    type: {
      type: String,
      default: "amount"
    },
    holdZero: {
      type: Boolean,
      default: true
    },
    modelTruncation: {
      type: Boolean,
      default: true
    },
    strictInput: {
      type: Boolean,
      default: false
    },
    plugin: Function,
    popUp: {
      type: Boolean,
      default: true
    },
    hideCurrency: {
      type: Boolean,
      default: false
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", _vm._b({
    ref: "root",
    staticClass: "tiny-amount"
  }, "div", _vm.a(_vm.$attrs, ["^on[A-Z]"]), false), [_c("tiny-popover", {
    attrs: {
      "placement": "bottom-start",
      "popper-class": "tiny-amount-popper" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "trigger": "manual",
      "append-to-body": _vm.popperAppendToBody
    },
    scopedSlots: _vm._u([{
      key: "reference",
      fn: function fn() {
        return [_c("tiny-input", {
          attrs: {
            "tabindex": _vm.tabindex,
            "size": _vm.size,
            "modelValue": _vm.getAmountText(),
            "maxlength": _vm.maxLen,
            "placeholder": _vm.placeholder,
            "disabled": _vm.disabled
          },
          on: {
            "focus": _vm.inputFocus,
            "blur": _vm.inputBlur,
            "update:modelValue": _vm.onInput
          },
          scopedSlots: _vm._u([{
            key: "suffix",
            fn: function fn2() {
              return [_c("div", {
                staticClass: "tiny-amount-input-icon",
                on: {
                  "click": _vm.toggleVisible
                }
              }, [_c("icon-coin", {
                staticClass: "tiny-svg-size"
              })], 1)];
            },
            proxy: true
          }])
        })];
      },
      proxy: true
    }]),
    model: {
      value: _vm.state.visible,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "visible", $$v);
      },
      expression: "state.visible"
    }
  }, [_c("div", {
    ref: "popover",
    staticClass: "popover-con"
  }, [_vm.popUp ? _c("div", {
    staticClass: "module"
  }, [_c("div", {
    staticClass: "popover-left"
  }, [_vm._v(_vm._s(_vm.t("ui.amount.currency")))]), _c("tiny-currency", {
    staticClass: "popover-right",
    attrs: {
      "clearable": false,
      "fields": _vm.fields,
      "fetch-currency": _vm.fetchCurrency,
      "popper-class": _vm.popperClass,
      "popper-append-to-body": _vm.popperAppendToBody,
      "currency": _vm.currency
    },
    model: {
      value: _vm.editorState.currency,
      callback: function callback($$v) {
        _vm.$set(_vm.editorState, "currency", $$v);
      },
      expression: "editorState.currency"
    }
  })], 1) : _vm._e(), _vm.date || _vm.dateAllowEmpty ? _c("div", {
    staticClass: "module"
  }, [_c("div", {
    staticClass: "popover-left"
  }, [_vm._v(_vm._s(_vm.t("ui.amount.date")))]), _c("tiny-date-picker", {
    staticClass: "popover-right",
    attrs: {
      "popper-class": "tiny-amount-popper" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "popper-append-to-body": _vm.popperAppendToBody
    },
    model: {
      value: _vm.editorState.date,
      callback: function callback($$v) {
        _vm.$set(_vm.editorState, "date", $$v);
      },
      expression: "editorState.date"
    }
  })], 1) : _vm._e(), _c("div", {
    staticClass: "module"
  }, [_c("div", {
    staticClass: "popover-left"
  }, [_vm._v(_vm._s(_vm.t("ui.amount.amount")))]), _c("tiny-input", {
    staticClass: "popover-right",
    attrs: {
      "maxlength": _vm.maxLen
    },
    on: {
      "update:modelValue": _vm.popInput
    },
    model: {
      value: _vm.editorState.amount,
      callback: function callback($$v) {
        _vm.$set(_vm.editorState, "amount", $$v);
      },
      expression: "editorState.amount"
    }
  })], 1), _c("div", {
    staticClass: "module"
  }, [_c("tiny-button", {
    attrs: {
      "type": "primary"
    },
    on: {
      "click": _vm.save
    }
  }, [_vm._v(_vm._s(_vm.t("ui.base.confirm")))]), _c("tiny-button", {
    on: {
      "click": _vm.reset
    }
  }, [_vm._v(_vm._s(_vm.t("ui.base.reset")))])], 1)])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Amount = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
Amount.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Amount.install = function(Vue) {
  Vue.component(Amount.name, Amount);
};
Amount.version = version;
export {
  Amount as default
};
